/*REPOSITORIO GITLAB: https://phoebe.roshka.com/gitlab/yalvarez/kotlin-e004-poker*/

class Carta(val valor: Int, val palo: Char)

/*Probar para validar*/
const val CARAS = "23456789tjqka"
const val LETRAS = "shdc"

/* corregir esta funcion y agregar la funcion para obtener poker , full*/
fun isStraight(cards: List<Carta>): Boolean {
    val sorted = cards.sortedBy { it.valor }
    if (sorted[0].valor + 4 == sorted[4].valor) return true
    if (sorted[4].valor == 14 && sorted[0].valor == 2 && sorted[3].valor == 5) return true
    return false
}
/* probar funciones*/
fun esColor(cartas: List<Carta>): Boolean {
    val suit = cartas[0].palo
    if (cartas.drop(1).all { it.palo == suit }) return true
    return false
}

fun jugada(mano: String): String {
    val h = mano.toLowerCase()
    val split = h.split(' ').filterNot { it == "" }.distinct()
    if (split.size != 5) return "invalid"
    val cartas = mutableListOf<Carta>()

    for (s in split) {
        if (s.length != 2) return "invalid"
        val fIndex = CARAS.indexOf(s[0])
        if (fIndex == -1) return "invalid"
        val sIndex = LETRAS.indexOf(s[1])
        if (sIndex == -1) return "invalid"
        cartas.add(Carta(fIndex + 2, s[1]))
    }

    val groups = cartas.groupBy { it.valor }
    when (groups.size) {
        2 -> {
            if (groups.any { it.value.size == 4 }) return " 4 tipos de cartas"
            return "full-house"
        }
        3 -> {
            if (groups.any { it.value.size == 3 }) return "3 tipos de cartas"
            return "DOS PARES"
        }
        4 -> return "UN PAR"
        else -> {
            val color = esColor(cartas)
            val straight = isStraight(cartas) //corregir
            when {
                color && straight -> return "straight-flush" //corregir
                color             -> return "color"
                straight          -> return "straight" //corregir
                else              -> return "Carta Alta"
            }
        }
    }
}

fun main(args: Array<String>) {
    val manos = arrayOf(
        "2h 2d 2c kc qd",
        "ah ah 7c 6c 4c"
    )
    for (mano in manos) {
        println("Jugada:  ${jugada(mano)}")
    }
}